var util = require('util'),
    YUI = require('yui3').YUI,
    EventEmitter = require('events').EventEmitter;

module.exports = new EventEmitter();

module.exports.setHost = function (host) {
    this.host = host;
}

module.exports.setRule = function (rule) {
    this.rule = rule;
}

module.exports.setCallback = function (callback) {
    this.callback = callback;
}

module.exports.setFormat = function (format) {
    this.format = format;
}

module.exports.fetch = function (config) {
    this.host = config.host;
    this.rule = config.rule;
    this.callback = config.callback || 'callback';
    this.format = config.format || 'outerHTML';

    var host = this.host,
        rule = this.rule,
        callback = this.callback,
        format = this.format,
        obj = {};

    if (host && rule) {
        YUI({ debug: false }).use('node', 'io', function (Y) {
            YUI({ debug: false }).use('node', function (remotePage) {
                remotePage.fetch(host, function () {
                    var results = remotePage.all(rule),
                        items = [], item;

                    results.each(function (n) {
                        item = n.get(format);
                        items.push(item);
                    });
                    obj.rule = rule;
                    obj.host = host;
                    obj.callback = callback;
                    obj.results = items;
                    module.exports.emit('data', obj);
                });
            });
        });
    }
}
